<?php
//--------------------------------------------------//
# Simple Player List by Flabaliki

# You do not need to edit this file
//--------------------------------------------------//

//Global Variables
$saveFile = "data.txt";
include "config.php";

//New variables that old versions may not have set
if(!isset($enableRankColors)){
	$enableRankColors = true;
}

//--------------------------------------------------//
//  The following sections writes data to the file  //
//--------------------------------------------------//

//Checks to make sure all data required was sent.
if(isset($_POST['Users']) && isset($_POST['Ranks']) && isset($_POST['ServerData']) && isset($_POST['Passcode']) && !isset($_POST['Status'])){
	
	//If the sent passcode matches the configuration one, saveData is called.
	if($_POST['Passcode'] == $passcode){
		saveData($_POST['Users'], $_POST['Ranks'], $_POST['ServerData'], "on");
	} else {
		die("Error: Passcodes do not match.");	
	}
	
	//Stop executing the file after writing data.
	die();
} else if(isset($_POST['Users']) && isset($_POST['Ranks']) && isset($_POST['ServerData']) && isset($_POST['Passcode']) && isset($_POST['Status'])){
	if($_POST['Passcode'] == $passcode){
		saveData($_POST['Users'], $_POST['Ranks'], $_POST['ServerData'], "off");
	} else {
		die("Error: Passcodes do not match.");	
	}
	
	//Stop executing the file after writing data.
	die();
	
}

function saveData($players, $ranks, $data, $status){
	$connectArray = getLastConnect();

	$saveFile = "data.txt";
	
	//Open file for writing.
	$fh = fopen($saveFile, 'w') or die("Error: Can't open $saveFile. On Linux, chmod this file to 664 or 666.");
	
	$dataToWrite = "Players=" . substr($players, 0, strlen($players) - 1) . "\n" . "Ranks=" . substr($ranks, 0, strlen($ranks) - 1) . "\n" . "ServerData=" . $data . "\n" . "Status=" . $status;
	
	//Write to and close the file
	fwrite($fh, $dataToWrite);
	fclose($fh);
	
	setLastConnect($connectArray[0], $connectArray[1]);	
}

function getLastConnect(){
	//Read the last connect time
	$fh = fopen("config.php", 'r') or die("Error: Can't open config.php. On Linux, chmod this file to 664 or 666.");
	$configFile = fread($fh, filesize("config.php"));
	fclose($fh);
	
	$connectTime = 0;
	$match='(\\$lastConnection = \\d+;)';	# Word 1
	if ($c=preg_match_all ("/".$match."/is",$configFile, $matches))
	  {
		  $connectTime = substr($matches[0][0], 18, strlen(substr($matches[0][0], 18)) - 1);
	  }
	
	return array($configFile, $connectTime);
}

function setLastConnect($configFile, $connectTime){
	$fh = fopen("config.php", 'w') or die("Error: Can't open config.php. On Linux, chmod this file to 664 or 666.");
	fwrite($fh, str_replace("$" . "lastConnection = " . $connectTime . ";", "$" . "lastConnection = " . strtotime("now") . ";", $configFile));
	fclose($fh);
	
}

//--------------------------------------------------//
//  The following sections reads and displays data  //
//                   from the file                  //
//--------------------------------------------------//

//Try to create the save file if it doesn't exist.
if (!file_exists($saveFile)) {
	$fh = fopen($saveFile, 'w') or die("Error: Can't open $saveFile. On Linux, chmod this file to 664 or 666.");
	fclose($fh);
} 

$fh = fopen($saveFile, 'r') or die("Error: Can't open $saveFile. On Linux, chmod this file to 664 or 666.");;
$currentData = fread($fh, filesize($saveFile));
fclose($fh);

//Put each player into an element of an array.
$players = explode("\n", $currentData);
$players = explode("Players=", $players[0]);
$players = explode(",", $players[1]);

//Put each rank into an element of an array.
$ranks = explode("\n", $currentData);
$ranks = explode("Ranks=", $ranks[1]);
$ranks = explode(",", $ranks[1]);

//Put the port and slot count into their own variables.
$serverData = explode("\n", $currentData);
$serverData = explode("ServerData=", $serverData[2]);
$serverData = explode(",", $serverData[1]);
$slots = $serverData[0];
$port = $serverData[1];
$delay = intval($serverData[2]) + 20;


//Begin printing the display
echo "<table>\n";

if (preg_match_all ("/(\\[.*?\\])/is", $template, $matches))
  {
	  foreach($matches[0] as $c){
		  switch ($c) {
			case "[Name]":
				printName($serverName, $delay);
				break;
			case "[IP]":
				printIP($port, $serverIP);
				break;
			case "[Players]":
				printPlayers($players, $ranks, $enableFaces, $faceSize, $enableRankColors, $faceGrid, $faceGridWidth);
				break;
			case "[Slots]":
				printSlots($players, $slots);
				break;
		  }
	  }
  }

echo "</table>";
//End printing the display

function printName($serverName, $delay){
	//Display server status and name.
	$connectArray = getLastConnect();
	if(serverOnline($delay)){
		echo "\t<tr><td colspan=\"2\"><table align=\"center\"><tr><td><img src=\"images/server-on.png\" title=\"" . $serverName . " is online\"/></td><td><strong>" . $serverName . "</strong></td></tr></table></td></tr>\n";	
	} else {
		echo "\t<tr><td colspan=\"2\"><table align=\"center\"><tr><td><img src=\"images/server-off.png\" title=\"" . $serverName . " is offline\"/></td><td>" . $serverName . "</td></tr></table></td></tr>\n";	
	}
}

function serverOnline($delay){	
	$saveFile = "data.txt";
	
	$fh = fopen($saveFile, 'r') or die("Error: Can't open $saveFile. On Linux, chmod this file to 664 or 666.");;
	$currentData = fread($fh, filesize($saveFile));
	fclose($fh);
	
	if(preg_match_all("/(Status=)([^$\n\r]*)/is", $currentData, $matches) && ($matches[2][0] == "off")){
		return false;	
	}
	
	$connectArray = getLastConnect();
	if($connectArray[1] < strtotime("-" . $delay)){
		
		return false;
	}
	
	return true;
}

function printIP($port, $serverIP){
	//Displays the servers IP and port.
	if($port != "25565"){
	echo "\t<tr><td colspan=\"2\" align=\"center\"><em>" . $serverIP . ":" . $port . "</em></td></tr>\n";
	} else {
		echo "\t<tr><td colspan=\"2\" align=\"center\"><em>" . $serverIP . "</em></td></tr>\n";
	}	
}

function printPlayers($players, $ranks, $enableFaces, $faceSize, $enableRankColors, $faceGrid, $faceGridWidth){
	if($players[0] != "" && $enableFaces && $faceGrid){
		$numPlayers = 0;
		foreach($players as $p){
			$numPlayers++;
		}
		
		faceGrid($faceGridWidth, $numPlayers, $players, $faceSize);
		return;
	}
	//List out all of the players
	$count = 0;
	foreach($players as $p){
		$tag = "";
		if($ranks[$count] != ""){
			$tag = $ranks[$count] . " ";
			if($enableRankColors){
				if (preg_match_all ("/(§([A-Fa-f0-9]))/is", $tag, $matches)){
					$colorCount = 0;
					foreach($matches[2] as $m){
						$m = strtolower($m);
						switch ($m) {
							case "0":
								$tag = str_replace("§0", "<span style=\"color:#000000;\">", $tag);
								break;
							case "1":
								$tag = str_replace("§1", "<span style=\"color:#0000aa;\">", $tag);
								break;
							case "2":
								$tag = str_replace("§2", "<span style=\"color:#00aa00;\">", $tag);
								break;
							case "3":
								$tag = str_replace("§3", "<span style=\"color:#00aaaa;\">", $tag);
								break;
							case "4":
								$tag = str_replace("§4", "<span style=\"color:#aa0000;\">", $tag);
								break;
							case "5":
								$tag = str_replace("§5", "<span style=\"color:#aa00aa;\">", $tag);
								break;
							case "6":
								$tag = str_replace("§6", "<span style=\"color:#ffaa00;\">", $tag);
								break;
							case "7":
								$tag = str_replace("§7", "<span style=\"color:#aaaaaa;\">", $tag);
								break;
							case "8":
								$tag = str_replace("§8", "<span style=\"color:#555555;\">", $tag);
								break;
							case "9":
								$tag = str_replace("§9", "<span style=\"color:#5555ff;\">", $tag);
								break;
							case "a":
								$tag = str_ireplace("§a", "<span style=\"color:#55ff55;\">", $tag);
								break;
							case "b":
								$tag = str_ireplace("§b", "<span style=\"color:#55ffff;\">", $tag);
								break;
							case "c":
								$tag = str_ireplace("§c", "<span style=\"color:#ff5555;\">", $tag);
								break;
							case "d":
								$tag = str_ireplace("§d", "<span style=\"color:#ff55ff;\">", $tag);
								break;
							case "e":
								$tag = str_ireplace("§e", "<span style=\"color:#ffff55;\">", $tag);
								break;
							case "f":
								$tag = str_ireplace("§f", "<span style=\"color:#ffffff;\">", $tag);
								break;
						}
						$colorCount++;
					}
					for($i = 0; $i < $colorCount; $i++){
						$tag = $tag . "</span>";	
					}
					
				}
			}
			
		}
		if($players[0] != "" && $enableFaces && getFace($p, $faceSize)){
			echo "\t<tr><td colspan=\"2\"><table align=\"center\"><tr><td align=\"center\"><img src=\"images/skins/" . $p . ".png\" width=\"" . $faceSize . "px\" height=\"" . $faceSize . "px\"  title=\"" . $p . "\" /></td><td>" . $tag . $p . "</td></tr></table></td></tr>\n";
		} else if($players[0] != "" && $enableFaces) {
			echo "\t<tr><td colspan=\"2\" align=\"center\"><table><tr><td align=\"center\"><img src=\"images/skins/default.png\" width=\"" . $faceSize . "px\" height=\"" . $faceSize . "px\  title=\"" . $p . "\" /></td><td>" . $tag . $p . "</td></tr></table></td></tr>\n";
		} else {
			echo "\t<tr><td colspan=\"2\" align=\"center\">" . $tag . $p . "</td></tr>\n";
		}
		$count++;
	}	
}

function getFace($user, $faceSize) {
	//Fetches a users skin and crops to the face, then resizes it and caches it.
	//Only get the file if it doesn't exist OR it is older than 1 hour.
	if((file_exists("images/skins/" . $user . ".png") && filemtime("images/skins/" . $user . ".png") <= time()-60*60) || !file_exists("images/skins/" . $user . ".png"))  {

		
		if(file_exists("images/skins/" . $user . ".png")){
				unlink("images/skins/" . $user . ".png");
		}
		// Create url to users skin.
		$filename = "http://s3.amazonaws.com/MinecraftSkins/" . $user . ".png";
		$newFile = "images/skins/" . str_replace("http://s3.amazonaws.com/MinecraftSkins/", "", $filename);
		 
		 //Check that the user has a skin
		 get_headers($filename);
		 if($http_response_header[0] == "HTTP/1.1 403 Forbidden"){return false;}
		
		// Get dimensions of the original image
		list($current_width, $current_height) = getimagesize($filename);
		// The x and y coordinates on the original image where we
		// will begin cropping the image
		$left = 8;
		$top = 8;
		 
		// This will be the final size of the image (e.g. how many pixels
		// left and down we will be going)
		$crop_width = $faceSize;
		$crop_height = $faceSize;
		 
		ini_set('gd.png_ignore_warning', 1);
		 
		// Resample the image
		$canvas = imagecreatetruecolor($crop_width, $crop_height);
		$current_image = imagecreatefrompng($filename);
		imagecopyresized ($canvas , $current_image , 0 , 0 , $left , $top , $crop_width * 8, $crop_height * 8, $current_width , $current_width );
		imagepng($canvas, $newFile, 9);		
		return true;
	}
	return true;
}

function printSlots($players, $slots){
	//Displays the servers current number of online users and the total number of slots
	if($players[0] != ""){
	echo "\t<tr><td colspan=\"2\" align=\"center\">" . count($players) . "/" . $slots . "</td></tr>\n";
	} else {
		echo "\t<tr><td colspan=\"2\" align=\"center\">0/" . $slots . "</td></tr>\n";
	}	
}

//Print the online uses in a grid format.
function faceGrid($width, $numPlayers, $player, $faceSize){
	
	//The height of the grid is equal to the number of players online, divided by the width
	//of the rows.
	$height = $numPlayers / $width;
	$count = 0;
	echo "<tr><td><table align=\"center\">";
	for ($i = 0; $i < $height; $i++){
		if($count == $numPlayers){break;}
		echo "<tr>";
			for($j = 0; $j < $width; $j++){
				if($count == $numPlayers){break;}
				if(getFace($player[$count], $faceSize)){
					echo "<td align=\"center\"><img src=\"images/skins/" . $player[$count] . ".png\" width=\"" . $faceSize . "px\" height=\"" . $faceSize . "px\"  title=\"" . $player[$count] . "\" /></td>";
				} else {
					echo "<td align=\"center\"><img src=\"images/skins/default.png\" width=\"" . $faceSize . "px\" height=\"" . $faceSize . "px\  title=\"" . $player[$count] . "\" /></td>";
				}
				
				$count++;
			}
		echo "</tr>";
	}
	echo "</table></td></tr>";
}
?>

<!--[ajax]a1[/ajax]-->